// *naka* - find a file within another file
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>

#include <ints.h>
#include <macros.h>
#include <version.h>

#include <tests.h>

// TODO: Have Makefile define these, or import them from Makefile defines.
#define PROG_NAME "naka"
#define PROG_DESCRIPTION "find a file within other file(s)"
#define PROG_AUTHOUR "Avril <flanchan@cumallover.me>"
#define PROG_LICENSE "GPL3+"
#define PROG_VERSION VERSION(0,0,0,0)

void prog_info(FILE* out)
{
	fprintf(out, PROG_NAME " v%s - " PROG_DESCRIPTION 
		"\n written by %s with <3\n  license %s.\n", 
			v_ctoss(v_rawtoc(PROG_VERSION)),
			PROG_AUTHOUR,
			PROG_LICENSE);
}

void usage(FILE* out, int argc, char** argv)
{
	IGNORE(argc);

	prog_info(out);
	fprintf(out, "\nUsage: %s <needle> <haystack(s)...>\n", argv[0] ?: PROG_NAME);
}

// err: 0 for normal exit and print to stdout.
// err: nonzero for abnormal exit and print to stderr.
noreturn void usage_then_exit(int err, int argc, char** argv)
{
	usage( err ? stderr : stdout, argc, argv);
	exit(err);
}

int main(int argc, char** argv)
{
	INFO("main start");
	
	usage_then_exit(0, argc, argv);

	INFO("main end");

	return 0;
}

